package org.iespuigcastellar.attendancemanager.screenlayouts;

import org.iespuigcastellar.attendancemanager.AttendancemanagerApplication;
import org.iespuigcastellar.attendancemanager.core.CreatePDF;
import org.iespuigcastellar.attendancemanager.core.DownloadResource;
import org.iespuigcastellar.attendancemanager.core.Group;
import org.iespuigcastellar.attendancemanager.core.Mailer;
import org.iespuigcastellar.attendancemanager.core.Term;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.text.DateFormat;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.ResourceBundle;

import com.vaadin.data.Item;
import com.vaadin.data.Property;
import com.vaadin.data.Property.ValueChangeEvent;
import com.vaadin.data.util.IndexedContainer;
import com.vaadin.terminal.ThemeResource;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.CheckBox;
import com.vaadin.ui.ComboBox;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Panel;
import com.vaadin.ui.PopupDateField;
import com.vaadin.ui.TextField;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Window.Notification;

/**
 * @deprecated Ha sido substituida por ReportLayout
 *
 */
@Deprecated
public class ReportsLayout extends VerticalLayout {
	private AttendancemanagerApplication app;
	private ResourceBundle rb = AttendancemanagerApplication.locale;
	
	private PopupDateField startDate;
	private PopupDateField endDate;
	
	private ComboBox reportComboBox;
	private ComboBox groupsComboBox;
	private ComboBox termsComboBox;
	
	private CheckBox bydateCheckBox;
	private CheckBox sendmailCheckBox;
	private CheckBox sendmailtoothersCheckBox;
	private CheckBox downloadCheckBox;
	private TextField othersTextField;
	private Button executeButton;
	private Button addButton;
	
	private DownloadResource dr;
	private CreatePDF pdf;
	private Mailer mailer;
	
	private void initLayout(){
		//Dates
		//POPUPS DATE
		startDate = new PopupDateField(rb.getString("REPORTSLAYOUT_STARTDATE_CAPTION"));
		startDate.setValue(new java.util.Date());
		startDate.setResolution(PopupDateField.RESOLUTION_DAY);
		startDate.setImmediate(true);
		startDate.setEnabled(false);

		endDate = new PopupDateField(rb.getString("REPORTSLAYOUT_ENDDATE_CAPTION"));
		endDate.setValue(new java.util.Date());
		endDate.setResolution(PopupDateField.RESOLUTION_DAY);
		endDate.setImmediate(true);
		endDate.setEnabled(false);
		
		//checkboxes
		bydateCheckBox = new CheckBox(rb.getString("REPORTSLAYOUT_BYDATECHECKBOX_CAPTION"));
		bydateCheckBox.setImmediate(true);
		
		sendmailtoothersCheckBox = new CheckBox(rb.getString("REPORTSLAYOUT_SENDMAILTOOTHERSCHECKBOX_CAPTION"));
		sendmailtoothersCheckBox.setImmediate(true);
		
		sendmailCheckBox=new CheckBox(rb.getString("REPORTSLAYOUT_SENDMAILCHECKBOX_CAPTION"));
		sendmailCheckBox.setImmediate(true);
		
		downloadCheckBox = new CheckBox(rb.getString("REPORTSLAYOUT_OPENORDOWNLOADCHECKBOX_CAPTION"));
		downloadCheckBox.setImmediate(true);
		downloadCheckBox.setValue(true);
		
		
		//TEXTFIELDS
		othersTextField= new TextField("");
		othersTextField.setEnabled(false);
		
		//BUTTONS
		executeButton = new Button(rb.getString("REPORTSLAYOUT_EXECUTEBUTTON_CAPTION"));
		executeButton.setIcon(new ThemeResource("img/lightning.png"));
		addButton = new Button(rb.getString("REPORTSLAYOUT_ADDBUTTON_CAPTION"));

		//Combos 
		groupsComboBox = new ComboBox(rb.getString("REPORTSLAYOUT_GROUPCOMBOBOX_CAPTION"));
		groupsComboBox.setNullSelectionAllowed(false);
		groupsComboBox.setImmediate(true);
		groupsComboBox.setRequired(false);
		groupsComboBox.setFilteringMode(ComboBox.FILTERINGMODE_CONTAINS);
		groupsComboBox.setReadThrough(true);	
		groupsComboBox.setWidth("100%");
		
		reportComboBox = new ComboBox(rb.getString("REPORTSLAYOUT_REPORTCOMBOBOX_CAPTION"));
		reportComboBox.setNullSelectionAllowed(false);
		reportComboBox.setImmediate(true);
		reportComboBox.setRequired(false);
		reportComboBox.setFilteringMode(ComboBox.FILTERINGMODE_CONTAINS);
		reportComboBox.setReadThrough(true);	
		reportComboBox.setWidth("100%");
		
		termsComboBox = new ComboBox(rb.getString("REPORTSLAYOUT_TERMCOMBOBOX_CAPTION"));
		termsComboBox.setNullSelectionAllowed(false);
		termsComboBox.setImmediate(true);
		termsComboBox.setRequired(false);
		termsComboBox.setFilteringMode(ComboBox.FILTERINGMODE_CONTAINS);
		termsComboBox.setReadThrough(true);	
		termsComboBox.setWidth("100%");
		
		
		//Layouts
		VerticalLayout datesLayout = new VerticalLayout();
		
		datesLayout.addComponent(startDate);
		datesLayout.addComponent(endDate);
		
		VerticalLayout termsdatesLayout = new VerticalLayout();
		termsdatesLayout.setSpacing(true);
		termsdatesLayout.addComponent(termsComboBox);
		termsdatesLayout.addComponent(datesLayout);
		
		
		HorizontalLayout combosLayout= new HorizontalLayout();
		combosLayout.setSpacing(true);
		combosLayout.addComponent(reportComboBox);
		combosLayout.addComponent(groupsComboBox);
		combosLayout.addComponent(termsdatesLayout);
		combosLayout.addComponent(bydateCheckBox);
		combosLayout.setComponentAlignment(bydateCheckBox, Alignment.MIDDLE_CENTER);

				
		HorizontalLayout mailersLayout = new HorizontalLayout();
		mailersLayout.setSpacing(true);
		mailersLayout.addComponent(sendmailtoothersCheckBox);
		mailersLayout.addComponent(othersTextField);
		mailersLayout.addComponent(executeButton);
		mailersLayout.setComponentAlignment(sendmailtoothersCheckBox, Alignment.MIDDLE_LEFT);
		
		Panel panelcontents = new Panel(rb.getString("REPORTSLAYOUT_PANELCONTENTS_CAPTION"));
		panelcontents.setSizeFull();
		
		panelcontents.addComponent(combosLayout);
		panelcontents.addComponent(downloadCheckBox);
		panelcontents.addComponent(sendmailCheckBox);
		panelcontents.addComponent(mailersLayout);
		
		addComponent(panelcontents);
		VerticalLayout vl=(VerticalLayout)panelcontents.getContent();
		vl.setSpacing(true);
		setSizeFull();
	}
	
	public void attach(){
		app=(AttendancemanagerApplication)getApplication();

		pdf = new CreatePDF();
		//rb = ResourceBundle.getBundle("AttendanceManager");
		mailer = new Mailer();
		
		initLayout();
		loadGroups();
		loadTerms();
		loadReports();
		
		addButton.addListener(new Button.ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {

				TextField newContact = new TextField();
			}
		});
		
		executeButton.addListener(new Button.ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {

				//DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT, new Locale(rb.getString("locale")));
				DateFormat df = AttendancemanagerApplication.df;
				
				ByteArrayOutputStream byteArrayOutputStreamPDF;
				boolean sendMail = false;
				String other=null;
				String emailMe=null;
				switch (getSelectedReport()){
				case 0:// Faltas por grupo
					try {
						byteArrayOutputStreamPDF = pdf.createReport1(getSelectedGroup(), getSelectedStartDate(), getSelectedEndDate());
						if(isForOpenReport()){
							System.out.println("Abriendo documento... " + df.format(new Date()));
							ByteArrayInputStream bi = new ByteArrayInputStream(byteArrayOutputStreamPDF.toByteArray());

							dr = new DownloadResource(bi, getApplication(), "Informe_"+df.format(new Date()).replaceAll("\\s", "_")+".pdf", "application/pdf");
							getWindow().open(dr);
						}
						if(isForSendToOthersReport()){
							sendMail = true;
							other = othersTextField.getValue().toString();
						}
						if (isForSendMeReport()){
							sendMail = true;
							emailMe = app.user.getEmail();
						}
						if (sendMail){
							if (emailMe != null && other != null){ 
								String[] to = { other , emailMe };
								mailer.setTo(to);
							}
							else if(emailMe != null){
								String[] to = { emailMe };
								mailer.setTo(to);
							}
							else if(other != null){
								String[] to = { other };
								mailer.setTo(to);
							}
														
							mailer.setSubject("Informe por grupos del " + getSelectedStartDate() + " a " + getSelectedEndDate());
							mailer.setBodyText("Informe del grupo " + getSelectedGroup() + " el día " + getSelectedStartDate() + " al día " + getSelectedEndDate());
							mailer.addMailAttachment(byteArrayOutputStreamPDF.toByteArray(), "application/pdf", "Informe_"+df.format(new Date())+".pdf");
							mailer.sendMail();
/* CONFLICTO VERSIÓN VIEJA !!!
							dr = new DownloadResource(bi, getApplication(), "Informe_por_grupos.pdf", "application/pdf");
							getWindow().open(dr);
						}
						if(isForSendToOthersReport() || isForSendMeReport()){
							sendMail(byteArrayOutputStreamPDF,rb.getString("REPORTSLAYOUT_LOADREPORTS_REPORT1"));
*/

						}
						
					} catch (Exception e) {
						e.printStackTrace();
					}
					break;
				case 1 :
					try {
						byteArrayOutputStreamPDF= pdf.createReport2(getSelectedGroup(), getSelectedStartDate(), getSelectedEndDate());
						if(isForOpenReport()){
							System.out.println("Abriendo documento...");
							ByteArrayInputStream bi= new ByteArrayInputStream(byteArrayOutputStreamPDF.toByteArray());

							dr = new DownloadResource(bi, getApplication(), "Informe_"+df.format(new Date())+".pdf", "application/pdf");
							getWindow().open(dr);
						}
						if(isForSendToOthersReport()){
							sendMail = true;
							other = othersTextField.getValue().toString();
						}
						if (isForSendMeReport()){
							sendMail = true;
							emailMe = app.user.getEmail();
						}
						if (sendMail){
							if (emailMe != null && other != null){ 
								String[] to = { other , emailMe };
								mailer.setTo(to);
							}
							else if(emailMe != null){
								String[] to = { emailMe };
								mailer.setTo(to);
							}
							else if(other != null){
								String[] to = { other };
								mailer.setTo(to);
							}
														
							mailer.setSubject("Informe por asignatura del " + getSelectedStartDate() + " a " + getSelectedEndDate());
							mailer.setBodyText("Informe del grupo " + getSelectedGroup() + " el día " + getSelectedStartDate() + " al día " + getSelectedEndDate());
							mailer.addMailAttachment(byteArrayOutputStreamPDF.toByteArray(), "application/pdf", "Informe_"+df.format(new Date())+".pdf");
							mailer.sendMail();

/*
							dr = new DownloadResource(bi, getApplication(), "Informe_por_asignaturas.pdf", "application/pdf");
							getWindow().open(dr);
						}
						if(isForSendToOthersReport() || isForSendMeReport()){
							sendMail(byteArrayOutputStreamPDF,rb.getString("REPORTSLAYOUT_LOADREPORTS_REPORT2"));
*/

						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					break;
				case 2 :
					try {
						byteArrayOutputStreamPDF= pdf.createReport3(getSelectedGroup(), getSelectedStartDate(), getSelectedEndDate());
						if(isForOpenReport()){
							System.out.println("Abriendo documento...");
							ByteArrayInputStream bi= new ByteArrayInputStream(byteArrayOutputStreamPDF.toByteArray());

							dr = new DownloadResource(bi, getApplication(), "Informe_"+df.format(new Date())+".pdf", "application/pdf");
							getWindow().open(dr);
						}
						if(isForSendToOthersReport()){
							sendMail = true;
							other = othersTextField.getValue().toString();
						}
						if (isForSendMeReport()){
							sendMail = true;
							emailMe = app.user.getEmail();
						}
						if (sendMail){
							if (emailMe != null && other != null){ 
								String[] to = { other , emailMe };
								mailer.setTo(to);
							}
							else if(emailMe != null){
								String[] to = { emailMe };
								mailer.setTo(to);
							}
							else if(other != null){
								String[] to = { other };
								mailer.setTo(to);
							}
														
							mailer.setSubject("Informe semanal del " + getSelectedStartDate() + " a " + getSelectedEndDate());
							mailer.setBodyText("Informe semanal del grupo " + getSelectedGroup() + " el día " + getSelectedStartDate() + " al día " + getSelectedEndDate());
							mailer.addMailAttachment(byteArrayOutputStreamPDF.toByteArray(), "application/pdf_", "Informe"+df.format(new Date())+".pdf");
							mailer.sendMail();

/*
							dr = new DownloadResource(bi, getApplication(), "Informe_semanal.pdf", "application/pdf");
							getWindow().open(dr);
						}
						if(isForSendToOthersReport() || isForSendMeReport()){
							sendMail(byteArrayOutputStreamPDF,rb.getString("REPORTSLAYOUT_LOADREPORTS_REPORT3"));
*/

						}
					} catch (Exception e) {
						e.printStackTrace();
					}
					break;
					
				}
				
			}
		});
				  /*getWindow().showNotification(
						  rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_REPORT") + " " + getSelectedReport()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_GROUP") + " " + getSelectedGroup()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_TERM") + " " + getSelectedTerm()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_STARTDATE") + " " + getSelectedStartDate()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_ENDDATE") + " " + getSelectedEndDate()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_DOCUMENT") + " " + isForOpenReport()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_SENDMAIL") + " " + isForSendToOthersReport()
						  + rb.getString("REPORTSLAYOUT_EXECUTEWINDOW_SENDMAILTOOTHERS") + " " + isForSendToOthersReport());*/
				  
		bydateCheckBox.addListener(new Property.ValueChangeListener() {
			
			@Override
			public void valueChange(ValueChangeEvent event) {

					termsComboBox.setEnabled(! bydateCheckBox.booleanValue());
					startDate.setEnabled(bydateCheckBox.booleanValue());
					endDate.setEnabled(bydateCheckBox.booleanValue());
				}
				
			
		});
		
		sendmailtoothersCheckBox.addListener(new Property.ValueChangeListener() {
			
			@Override
			public void valueChange(ValueChangeEvent event) {

				othersTextField.setEnabled(sendmailtoothersCheckBox.booleanValue());
				}
				
			
		});
		
		reportComboBox.addListener(new Property.ValueChangeListener(){

			@Override
			public void valueChange(ValueChangeEvent event) {

				if((Integer)reportComboBox.getValue()==2){ 
					startDate.setEnabled(true);
					endDate.setEnabled(true);
					termsComboBox.setEnabled(false);
					}
				else { 
					termsComboBox.setEnabled(true);
					startDate.setEnabled(false);
					endDate.setEnabled(false);
				}
			}

			
		});
		
	}
	private String getEmailOthers(){
		if (isForSendToOthersReport()){
			return (String) othersTextField.getValue();
		}else{
			return null;
		}
	}
	private Boolean isForSendToOthersReport(){
		return sendmailtoothersCheckBox.booleanValue();
	}
	private Boolean isForSendMeReport(){	
		return sendmailCheckBox.booleanValue();
	}
	private Boolean isForOpenReport(){
		return downloadCheckBox.booleanValue();
	}
	private Integer getSelectedGroup(){
		return (Integer) groupsComboBox.getValue();
	}
	private java.util.Date getSelectedStartDate(){
		if (bydateCheckBox.booleanValue()){
			return (Date) startDate.getValue();
		}else{
			return (Date) termsComboBox.getContainerDataSource().getContainerProperty(termsComboBox.getValue(), "start").getValue();
		}
	}
	private java.util.Date getSelectedEndDate(){
		if (bydateCheckBox.booleanValue()){
			return (Date) endDate.getValue();
		}else{termsComboBox.setEnabled(! bydateCheckBox.booleanValue());
			return (Date) termsComboBox.getContainerDataSource().getContainerProperty(termsComboBox.getValue(), "end").getValue();
		}
	}
	private Integer getSelectedTerm(){
		if (! bydateCheckBox.booleanValue()){
			return (Integer) termsComboBox.getValue();
		}else{
			return null;
		}
	}
	private Integer getSelectedReport(){
		return (Integer) reportComboBox.getValue();
	}
	
	private void loadReports(){
		IndexedContainer ic=new IndexedContainer();
		ic.addContainerProperty("namereport", String.class, null);
	
	
		Item itemTerm=ic.addItem(0);
		itemTerm.getItemProperty("namereport").setValue(rb.getString("REPORTSLAYOUT_LOADREPORTS_REPORT1"));
		itemTerm=ic.addItem(1);
		itemTerm.getItemProperty("namereport").setValue(rb.getString("REPORTSLAYOUT_LOADREPORTS_REPORT2"));
		itemTerm=ic.addItem(2);
		itemTerm.getItemProperty("namereport").setValue(rb.getString("REPORTSLAYOUT_LOADREPORTS_REPORT3"));
		
		reportComboBox.setContainerDataSource(ic);
		reportComboBox.setItemCaptionPropertyId("namereport");
		reportComboBox.setValue(0);
	}

	private void loadGroups(){
		
        Collection collection = AttendancemanagerApplication.storage.allGroups(app.user);

        IndexedContainer ic=new IndexedContainer();
        ic.addContainerProperty("namegroup", String.class, null);
        Iterator<Group> it =collection.iterator();
        Integer firstItem=null;
        Item itemGroup=null;//ic.addItem(0);
        //itemGroup.getItemProperty("namegroup").setValue(rb.getString("REPORTSLAYOUT_LOADTERMS_ALLGROUPS"));
        while (it.hasNext()){
            Group group=it.next();
            if (firstItem==null){firstItem=group.getID();}
            itemGroup=ic.addItem(group.getID());
            itemGroup.getItemProperty("namegroup").setValue(group.getName());
        }
        groupsComboBox.setContainerDataSource(ic);
        groupsComboBox.setItemCaptionPropertyId("namegroup");
        if (firstItem!=null){groupsComboBox.setValue(firstItem);};
    }

	private void loadTerms(){
        Collection collection = app.storage.allTerms();
        IndexedContainer ic=new IndexedContainer();
        ic.addContainerProperty("term", String.class, null);
        ic.addContainerProperty("start", java.util.Date.class, null);
        ic.addContainerProperty("end", java.util.Date.class, null);
        Iterator<Term> it =collection.iterator();
        Integer firstItem=null;
        Item itemTerm=null;//ic.addItem(0);
        //itemTerm.getItemProperty("term").setValue(rb.getString("REPORTSLAYOUT_LOADTERMS_ALLTERMS"));
        while (it.hasNext()){
            Term term=it.next();
            if (firstItem==null){firstItem=term.getID();}
            itemTerm=ic.addItem(term.getID());
            itemTerm.getItemProperty("term").setValue(term.getName());
            itemTerm.getItemProperty("start").setValue(term.getStart());
            itemTerm.getItemProperty("end").setValue(term.getEnd());
        }
        termsComboBox.setContainerDataSource(ic);
        termsComboBox.setItemCaptionPropertyId("term");
        if (firstItem!=null){termsComboBox.setValue(firstItem);};   
    	}

	private void sendMail(ByteArrayOutputStream byteArrayOutputStreamPDF , String report){
		boolean sendMail = false;
		String other="";
		String emailMe="";
		if(isForSendToOthersReport()){
			sendMail = true;
			other = othersTextField.getValue().toString();
		}
		if (isForSendMeReport()){
			sendMail = true;
			emailMe = app.user.getEmail();
		}
		if (sendMail){
			String unvalidAddress ="";
			boolean sendIt = false;
			if (mailer.isValidEmailAddress(emailMe) && mailer.isValidEmailAddress(other)){ 
				String[] to = { other , emailMe };
				mailer.setTo(to);
				sendIt = true;
			}
			else if (!mailer.isValidEmailAddress(emailMe) && !mailer.isValidEmailAddress(other)){
				unvalidAddress = other +" "+ emailMe;
			}
			else if(mailer.isValidEmailAddress(emailMe) && !mailer.isValidEmailAddress(other)){
				String[] to = { emailMe };
				mailer.setTo(to);
				unvalidAddress = other;
				sendIt = true;
			}
			else if(!mailer.isValidEmailAddress(emailMe) && mailer.isValidEmailAddress(other)){
				String[] to = { other };
				mailer.setTo(to);
				unvalidAddress = emailMe;
				sendIt = true;
			}
			
			if (sendIt){
				mailer.setSubject(report);
				mailer.setBodyText("Generación de informes de Gestión de faltas de asistencia\n\t- "+report+" adjunto");
				mailer.addMailAttachment(byteArrayOutputStreamPDF.toByteArray(), "application/pdf", report+".pdf");
				mailer.sendMail();
				if (unvalidAddress == ""){
					getParent().getWindow().showNotification(
							rb.getString("REPORTSLAYOUT_SUCCESSMAIL_MESSAGE") + mailer.getToElements(),
							Notification.TYPE_TRAY_NOTIFICATION);
				}
				else{
				getParent().getWindow().showNotification(
						rb.getString("REPORTSLAYOUT_SUCCESSMAIL_MESSAGE") + mailer.getToElements(),
						rb.getString("REPORTSLAYOUT_UNSUCCESSMAIL_MESSAGE") + unvalidAddress ,
						Notification.TYPE_TRAY_NOTIFICATION);
				}
			}
			else{
				getParent().getWindow().showNotification(
						rb.getString("REPORTSLAYOUT_FAILSENDMAIL_MESSAGE"), unvalidAddress , Notification.TYPE_ERROR_MESSAGE);
			}
		}
	}

}
